package repeat;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.*;

/** A tag that repeats the body the specified
 *  number of times.
 *  <P>
 *  Taken from More Servlets and JavaServer Pages
 *  from Prentice Hall and Sun Microsystems Press,
 *  http://www.moreservlets.com/.
 *  &copy; 2002 Marty Hall; may be freely used or adapted.
 */

public class RepeatTag extends BodyTagSupport {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int reps;

	public void setReps(String repeats) {
		try {
			reps = Integer.parseInt(repeats);
		} catch(NumberFormatException nfe) {
			reps = 1;
		}
	}

	public int doAfterBody() {
		if (reps-- >= 1) {
			BodyContent body = getBodyContent();
			try {
				JspWriter out = body.getEnclosingWriter();
				out.println(body.getString());
				body.clearBody(); // Clear for next evaluation
			} catch(IOException ioe) {
				System.out.println("Error in RepeatTag: " + ioe);
			}
			return(EVAL_BODY_AGAIN);
		} else {
			return(SKIP_BODY);
		}
	}
}
